/*
(C) 15.2.2000  Petr Latovika

Vsledek je v kdovn CP852 !

pentamin 3 20   -> 2 een
pentamin 4 15   -> 368 een
pentamin 5 12   -> 1010 een

pentamin ka vka 0  - tvary se mohou opakovat bez omezen
pentamin ka vka n  - kad tvar lze pout n krt
pentamin ka vka    - poet omezen podle pol poctymin,poctymax

een, kter jsou symetrick barevn (bez ohledu na hranice kostek), jsou
na vstupu vckrt.

*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

struct Txy{ int x,y;} data[]={ //kad kostka kon 0,0
0,1,0,2,0,3,0,4,0,0,  0,1,0,2,0,3,1,0,0,0, 0,1,0,2,0,3,1,1,0,0,
0,1,1,1,1,2,1,3,0,0,  0,1,0,2,1,0,2,0,0,0, 0,1,0,2,1,0,1,1,0,0,
0,1,0,2,1,0,1,2,0,0,  1,0,2,0,1,1,1,2,0,0, 1,0,1,1,1,2,2,1,0,0,
0,1,1,1,2,1,2,2,0,0, -1,1,0,1,0,2,1,1,0,0, 1,0,1,1,2,1,2,2,0,0
};
int poctymax[]={1,1,1,1,1,1,1,1,1,1,1,1}; //-1 => neomezeno , 0 => vynechat
int poctymin[]={0,0,0,0,0,0,0,0,0,0,0,0};

int pocty=-1; //-1 => ber z pol poctymax,poctymin
int xm=5,ym=12; //rozmry
//--------------------------------------------------------------------------

struct Tpole{
 int h,b; //hloubka,barva
} *A, //plocha
  *pm, //ukazatel za posledn polko
  *p; //ukazatel na prvn neobsazen polko

int hloubka;
long Nreseni;
FILE *fo;

struct Tpoloha{
 Tpoloha *nxt;
 int l,r; //vzdlenost lev a prav strany od levho dolnho rohu kostky
 int *a; //vzdlenosti tverek od levho dolnho rohu kostky v poli A
         //zvis na ce pole A
 Tpoloha(int xl,int xr,int *p,Tpoloha *n):nxt(n),l(xl),r(xr),a(p){};
 ~Tpoloha(){ delete[] a;}
};

struct Tkostka{
 Tkostka *nxt;
 Tpoloha *polohy; //seznam vech rotac tto kostky
 int barva;
 int poc,zbytek;
 Tkostka(int b,int p,int z,Tkostka *k):barva(b),poc(p),zbytek(z),
    polohy(0),nxt(k){};
 ~Tkostka();
} *kostky=0;

Tkostka::~Tkostka(){
Tpoloha *k,*k1;
 for(k=polohy; k; k=k1){ k1=k->nxt; delete k;}
}


// Pro ohranien je teba rozliovat i stejn kostky,
// ale pro test shody po natoen se nerozliuj.
void zapis(){
Tkostka *kostka;
Tpole *u,*v,*u1,*v1;
int l,r,h,d,lr,hd;
int i;

//test, jestli byly pouity vechny povinn kostky
 for(kostka=kostky; kostka; kostka=kostka->nxt){
   if(kostka->poc > kostka->zbytek) return;
 }
//ze stejnch een (po rotaci) vyber to s nejmenm prvnm polkem
 //lev-prav
 for(u=A, v=A+xm-1; u<v; u+=xm, v+=xm){
  if(u>=pm) u+=A-pm+1, v+=A-pm-1;
  if(u->b>v->b) return;
  if(u->b<v->b) break;
 }
 //doln-horn
 for(i=xm, u=A, v=pm-xm; u<v; i--, u++, v++){
  if(!i) i=xm, v-=xm*2;
  if(u->b>v->b) return;
  if(u->b<v->b) break;
 }
 //stedov soumrnost
 for(u=A, v=pm-1; u<v; u++, v--){
  if(u->b>v->b) return;
  if(u->b<v->b) break;
 }
 //peklopen podle hlopky (jen u tvercov plochy)
 if(xm==ym)
  for(u=u1=A+xm-1, v=v1=pm-xm; u<v; u+=xm+1, v+=xm+1){
   if(v>=pm) u=(--u1), v=(v1-=xm);
   if(u->b>v->b) return;
   if(u->b<v->b) break;
  }
//zapi plochu A do souboru fo
 Nreseni++;
 for(int x=0; x<=xm; x++){
  for(int y=0; y<=ym; y++){
   u=A+x+y*xm;
   lr= !x || x==xm;
   hd= !y || y==ym;
   l= (hd && x>0)  || x && u[-1-xm].h!=u[-1].h;
   r= (hd && x<xm) || x<xm && u[-xm].h!=u[0].h;
   h= (lr && y<ym) || y<ym && u[-1].h!=u[0].h;
   d= (lr && y>0)  || y && u[-xm-1].h!=u[-xm].h;
   fputc("     ٴ"[d*8+h*4+l*2+r],fo);
   fputc(y<ym ? (h ? '':' ') : '\n',fo);
  }
 }
}

//backtracking
void f(){
Tkostka *kostka;
Tpoloha *k;
Tkostka **pred=&kostky;
int barva;
int *a;
Tpole *pl;
int xl,xr;

//posu se na dal neobsazen polko
 pl=p; //uchovej pozici
 while((++p)->b){
  if(p==pm){ zapis(); p=pl; return;} //nalezeno een
 }
//vzdlenosti p od okraj
 xl=(p-A) % xm;
 xr=xm-xl; //o 1 vt !
//zkus vechny mon rotace kostek
 for(kostka=kostky; kostka; kostka=*(pred=&kostka->nxt)){
  barva=kostka->barva;
  for(k=kostka->polohy; k; k=k->nxt){
   if(xr> k->r && xl>= k->l){ //testuj okraje
    for(a=k->a; !p[*a].b; a++){ //zjisti, zda je voln msto
     if(!*a){
      //umsti kostku
       p->b=barva, p->h=hloubka;
       for(a=k->a; *a; a++) p[*a].b=barva, p[*a].h=hloubka;
       if(!--kostka->poc) *pred=kostka->nxt; //vyho kostku ze seznamu
       hloubka++;
       f(); //rekurze
       hloubka--;
       ++kostka->poc;
       *pred=kostka;
       p->b=0;
       for(a=k->a; *a; a++) p[*a].b=0;
       break;
     }
    }
   }
  }
 }
 p=pl;
}


void vytvor(){
int barva=0;
Tpoloha *k;
int i,i0,j,ip,zrc,rot,w,maxx,minx,x0,y0,x,y,Da;
int *a1;

for(i0=ip=0; ip<sizeof(poctymax)/sizeof(*poctymax); i0+=Da+1,ip++){
 //zjisti Da = poet plnch tverek tto kostky - 1
 for(i=i0; data[i].x || data[i].y; i++);
 Da=i-i0;
 if(pocty>=0 || poctymax[ip]){
  //pidej kostku do seznamu
  w=pocty<0 ? poctymax[ip]:pocty;
  if(!(kostky=new Tkostka(++barva,w,w-(pocty<0 ? poctymin[ip]:0),kostky)))
     exit(1);
  for(zrc=0; zrc<2; zrc++){
   for(rot=0; rot<4; rot++){
   //najdi okraje a lev doln roh
    maxx=minx=x0=y0=0;
    for(i=i0; i<i0+Da ; i++){
      x=data[i].x, y=data[i].y;
      if(x<minx) minx=x;
      if(x>maxx) maxx=x;
      if(y<y0) y0=y,x0=x;
      if(y==y0 && x<x0) x0=x;
    }
    if(maxx-minx<xm){//nevejde se vbec do plochy!
     if(!(a1=new int[Da+1])) exit(1);
    //lev doln roh posu na 0 a seti pole a1
     for(i=i0; i<i0+Da; i++){
       w=(data[i].x-x0)+(data[i].y-y0)*xm;
       if(!w) w=-x0-y0*xm;
       for(j=i-i0; j>0 && w<a1[j-1]; j--) a1[j]=a1[j-1];
       a1[j]=w;
     }
     a1[Da]=0;
    //zjisti, jestli u je v seznamu
     for(k=kostky->polohy; k; k=k->nxt){
       for(j=0; k->a[j]==a1[j] && a1[j]; j++);
       //rzn rotace mohou mt stejn k->a (li se jen v k->l)
       if(!a1[j] && k->l==x0-minx) break; //u tam je
     }
     if(k) delete[] a1;
     else //dej do seznamu
       if(!(kostky->polohy=new Tpoloha(x0-minx,maxx-x0,a1,kostky->polohy)))
          exit(1);
    }
    //rotace
    for(i=i0; i<i0+Da; i++){
      w=data[i].x; data[i].x=-data[i].y; data[i].y=w;
    }
   }
   //zrcadlov pevrcen
   for(i=i0; i<i0+Da; i++) data[i].x=-data[i].x;
  }
 }
}
}

main(int argc,char **argv){
Tkostka *kostka,*kostka1;
char *fs="pent0x00.txt";
int w;

//parametry
 if(argc>2) xm=atoi(argv[1]), ym=atoi(argv[2]);
 if(argc>3) pocty=atoi(argv[3]);
 if(xm<2) xm=2;
 if(ym<2) ym=2;
 if(xm>99) xm=99;
 if(ym>99) ym=99;
 if(xm>ym) w=xm,xm=ym,ym=w;
//alokace pole
 if(!(A=new Tpole[xm*(ym+5)])) exit(1);
 vytvor();
 memset(A,0,xm*ym*sizeof(Tpole));
 memset(pm = A+(xm*ym), 255, xm*5*sizeof(Tpole));
//oteven souboru
 if(pocty>=0) fs[2]=pocty%10+'0', fs[3]='_';
 if(xm>9) fs[3]=xm/10+'0';
 fs[4]=xm%10+'0'; fs[6]=ym/10+'0'; fs[7]=ym%10+'0';
 if(!(fo=fopen(fs,"w"))) printf("Nelze otevrit soubor.\n");
 else{
  Nreseni=hloubka=0;
  p=A-1;
  f();
  fprintf(fo,"\nPoet een: %ld\n",Nreseni);
  fclose(fo);
 }
 delete A;
 for(kostka=kostky; kostka; kostka=kostka1){
  kostka1=kostka->nxt;
  delete kostka;
 }
 return 0;
}